import argparse
import subprocess
import shlex
import os
import sys
from collections import OrderedDict
from os import path
from datetime import datetime
import re
from tempfile import mkstemp
from shutil import move
from os import remove

escalate_top_varname = 'ESCALATE_TOP_DIR'
conda_env_name = 'esc'

# The directory in which this script is located
this_script_dir = path.dirname(path.abspath(__file__))
escalate_top_path = os.environ.get(escalate_top_varname, path.join(os.getcwd(), 'escalate'))

# In case 'ESCALATE_TOP_DIR' was not in environ
os.environ[escalate_top_varname] = escalate_top_path

# The path where we await anaconda
conda_path = path.join(escalate_top_path, 'miniconda')

# Physical path of the conda environment
conda_env_path = path.join(conda_path, 'envs', conda_env_name)

# Should we install or build root
build_root = "--build-root" in sys.argv


# Print some path
print("escalate_top_path:", escalate_top_path)
print("mini-conda_path:  ", conda_path)
print("CERN ROOT: ", "Build from sources" if build_root else "Install with Conda")

# Set strict channel priority
# look here
# https://conda-forge.org/docs/user/tipsandtricks.html
# https://conda-forge.org/docs/minutes/2020-01-22.html
# https://docs.conda.io/projects/conda/en/latest/user-guide/tasks/manage-channels.html
# test
# conda config --describe channel_priority
#
condarc_content = """
channel_priority: strict
channels:
  - conda-forge
  - defaults
"""

template_user_sh = """
export {escalate_top_varname}={escalate_top_path}

# Start conda environment
source ${escalate_top_varname}/miniconda/etc/profile.d/conda.sh
conda activate esc

# The path where ejpm stores its JSon database and creates env files
export EJPM_DATA_PATH=${escalate_top_varname}/.ejpm_data

# This tells EJPM not to generate source thisroot.sh
export ROOT_INSTALLED_BY_CONDA=1
#export GEANT_INSTALLED_BY_CONDA=1

# source environment generated by EJPM
# means ROOT, GEANT and others
source $EJPM_DATA_PATH/env.sh
""".format(escalate_top_varname=escalate_top_varname, escalate_top_path=escalate_top_path)

template_user_csh = """
setenv {escalate_top_varname} {escalate_top_path}

# Start conda environment
source {conda_path}/etc/profile.d/conda.csh
conda activate esc

# The path where ejpm stores its JSon database and creates env files
setenv EJPM_DATA_PATH ${escalate_top_varname}/.ejpm_data

# This tells EJPM not to generate source thisroot.sh
setenv ROOT_INSTALLED_BY_CONDA 1
setenv GEANT_INSTALLED_BY_CONDA 1

# source environment generated by EJPM
# means ROOT, GEANT and others
source $EJPM_DATA_PATH/env.csh
""".format(conda_path=conda_path, escalate_top_varname=escalate_top_varname, escalate_top_path=escalate_top_path)

template_setup_conda = """
set -e
source {conda_path}/etc/profile.d/conda.sh
export {escalate_top_varname}={escalate_top_path}
conda config --set ssl_verify false
conda update -n base -y conda
conda create -y --name {conda_env_name} python=3.8
conda activate {conda_env_name}
{install_root}
conda install -y\\
        cmake\\
        xerces-c\\
        mesa-libgl-devel-cos6-x86_64\\
        mesa-dri-drivers-cos6-x86_64\\
        xorg-libxmu\\
        libselinux-cos6-x86_64\\
        libxdamage-cos6-x86_64\\
        libxxf86vm-cos6-x86_64\\
        clhep\\
        hepmc2\\
        pythia8\\
        git\\
        git-lfs\\
        nodejs\\
        boost\\
        ipywidgets\\
        zstd\\
        hepmc3\\
        geant4\\
    && echo "==========================================="\\
    && echo " C O N D A   I N S T A L L   S U C S E S S "\\
    && echo "==========================================="

# The path where ejpm stores its JSon database and creates env files
export EJPM_DATA_PATH=${escalate_top_varname}/.ejpm_data
mkdir -p ${escalate_top_varname}/.ejpm_data
which pip
pip install --upgrade\\
       click\\
       appdirs\\
       ejpm\\
       jupyterlab\\
       metakernel\\
       jupyter_nbextensions_configurator\\
       jupyter_contrib_nbextensions\\
       uproot awkward-numba\\
       numpy\\
       pandas\\
       matplotlib\\
       seaborn\\
       plotly\\
       pyjet\\
       pyjano\\
       wget\\
       flask\\
       smear

ejpm --top-dir=${escalate_top_varname}

ejpm config global cxx_standard=17

# so ejpm generated the right environemnt
export ROOT_INSTALLED_BY_CONDA=1
export GEANT_INSTALLED_BY_CONDA=1

# Set root which we installed before
{ejpm_set_root}
ejpm set pythia8 {conda_env_path}
ejpm set clhep  {conda_env_path}
ejpm set hepmc  {conda_env_path}
ejpm set hepmc3 {conda_env_path}
ejpm set geant  {conda_env_path}
""".format(
    conda_path=conda_path,
    conda_env_name=conda_env_name,
    conda_env_path=conda_env_path,
    escalate_top_varname=escalate_top_varname,
    escalate_top_path=escalate_top_path,
    build_root=build_root,
    install_root = "conda install -y root" if not build_root else "conda install -y root-dependencies",
    ejpm_set_root = "ejpm set root " + conda_env_path if not build_root else ""
    )

template_build_packets = """
set -e
echo ""
echo "================================================="
echo "  B U I L D   E S C A L A T E   P A C K A G E S"
echo "================================================="
echo ""

source {escalate_top_path}/escalate.sh

# if users has a RAVEPATH from some old environment, genfit will not build 
unset RAVEPATH

ejpm install geant -j 8 && ejpm clean geant
# ejpm install lhapdf -j 8
# ejpm install dire -j 8
ejpm config g4e branch=master
ejpm config ejana branch=master
ejpm install g4e -j 8
# ejpm install acts
ejpm install ejana
""".format(escalate_top_path=escalate_top_path)

template_jupyter_config = """
set -e
# Configuration file for jupyter-notebook.
import os
from pprint import pprint
from os import path
from os.path import dirname

c.NotebookApp.allow_origin = '*'
c.Spawner.args = ["--NotebookApp.allow_origin=*"]
c.JupyterHub.tornado_settings = { 'headers': { 'Access-Control-Allow-Origin': '*' } }

print('\\nESCALATE CONFIG PROCESSING\\n')

## Extra paths to search for serving static files.

this_script_dir = path.dirname(path.abspath(__file__))
# this_script_dir === $ESCALATE_TOP_PATH/miniconda/envs/esc/etc/jupyter
# 5 x dirnames to get to $ESCALATE_TOP_PATH
escalate_dir = dirname(dirname(dirname(dirname(dirname(this_script_dir)))))
extension_dir = path.join(escalate_dir, 'jupyter_extensions', 'static')

print(" == >This __file__   = '{}'".format(__file__))
print(" == > escalate_dir = '{}'".format(escalate_dir))

c.NotebookApp.extra_static_paths = [extension_dir]

# ROOT javascript is there:
if 'ROOTSYS' in os.environ:
    c.NotebookApp.extra_static_paths.append(os.path.join(os.environ['ROOTSYS'], 'js'))

print('c.NotebookApp.extra_static_paths:')
pprint(c.NotebookApp.extra_static_paths)

## Dict of Python modules to load as notebook server extensions.Entry values can
#  be used to enable and disable the loading ofthe extensions. The extensions
#  will be loaded in alphabetical order.
c.NotebookApp.nbserver_extensions = {'pyjano.notebook_extension': True}
"""

template_setup_jupyterlab = """
source {escalate_top_path}/escalate.sh

git clone https://gitlab.com/eic/escalate/jupyter_extensions.git {escalate_top_path}/jupyter_extensions
git clone https://gitlab.com/eic/escalate/workspace.git {escalate_top_path}/workspace
cd {escalate_top_path}/workspace
git lfs install --local
git lfs pull
cd -

jupyter labextension link {escalate_top_path}/jupyter_extensions/root_renderer
jupyter labextension install @jupyter-widgets/jupyterlab-manager
jupyter labextension list
jupyter serverextension enable pyjano.notebook_extension
jupyter serverextension list
""".format(escalate_top_path=escalate_top_path)


def run(command, cwd=None, shell=False, exit_on_error=True, silent=False):
    """Wrapper around subprocess.Popen that returns:

    :return retval, start_time, end_time, lines
    """
    if isinstance(command, str):
        command = shlex.split(command)

    # Pretty header for the command
    if not silent:
        print('=' * 20)
        print("RUN: " + " ".join(command))
        print('=' * 20)

    # Record the start time
    start_time = datetime.now()
    lines = []

    # stderr is redirected to STDOUT because otherwise it needs special handling
    # we don't need it and we don't care as C++ warnings generate too much stderr
    # which makes it pretty much like stdout
    process = subprocess.Popen(command, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, cwd=cwd, shell=shell)
    while True:
        line = process.stdout.readline().decode('latin-1').replace('\r', '\n')

        if process.poll() is not None and line == '':
            break
        if line:
            if line.endswith('\n'):
                line = line[:-1]
            if not silent:
                try:
                    # This try block is to fix 
                    # TypeError: endswith first arg must be bytes or a tuple of bytes, not str
                    # which may happen when building root under docker                    
                    print(line)
                except:
                    print(str(line.encode('utf-8')))
                lines.append(line)

    # Get return value and finishing time
    retval = process.poll()
    end_time = datetime.now()
    if not silent:
        print("------------------------------------------")
        print("RUN DONE. RETVAL: {} \n\n".format(retval))

    if retval != 0:
        if not silent:
            print("ERROR. Retval is not 0. Plese, look at the logs\n")
        if exit_on_error:
            exit(1)

    return retval, start_time, end_time, lines

def write_file_content(file_path, content):
    with open(file_path, 'w') as f:
        f.write(content)

def run_as_bash_script(script_path, content, silent=False):
    write_file_content(script_path, content)
    return run('bash '+script_path, shell=False, silent=silent)


def install_miniconda():
    # install miniconda
    if os.path.isdir(conda_path):
        print("Path already exists. Skipping installation step.")
        return

    import platform
    if 'Darwin' in platform.system():
        conda_install_sh_link = 'https://repo.anaconda.com/miniconda/Miniconda3-latest-MacOSX-x86_64.sh'
    else:
        conda_install_sh_link = 'https://repo.anaconda.com/miniconda/Miniconda3-latest-Linux-x86_64.sh'

    print("Downloading miniconda from {} ...".format(conda_install_sh_link))
    run('curl {conda_install_script} -o miniconda.sh'.format(conda_install_script=conda_install_sh_link))
    run("bash miniconda.sh -b -p " + conda_path)
    run("rm miniconda.sh")

    # setup conda environment
    condarc_path = path.join(conda_path, '.condarc')
    with open(condarc_path, 'w') as condarc_file:
        condarc_file.write(condarc_content)


def setup_conda():
    if is_conda_env_exist(conda_env_name):
        print("Environment {} exists. Skipping enironment creation ".format(conda_env_name))
        return

    # create epic environment with root
    run_as_bash_script(path.join(escalate_top_path, 'setup_conda.sh'), template_setup_conda)


def build_ejana_g4e():
    # create epic environment with root
    script_path = path.join(escalate_top_path, 'install_ejana_g4e.sh')
    run_as_bash_script(script_path, template_build_packets)


def is_conda_env_exist(env_name):
    conda_env_exe = path.join(conda_path, 'bin', 'conda-env')
    _, _, _, lines = run('{conda_env_exe} list'.format(conda_env_exe=conda_env_exe), silent=True)

    # Conda env list give something like:
    # # conda environments:
    #  base   <path>
    #  esc  * <path>
    pattern = re.compile("^{env_name}\\s".format(env_name=env_name))
    for line in lines:
        if pattern.match(line):
            return line


def generate_env_scripts():
    print("Generating escalate.sh and escalate.csh")
    write_file_content(path.join(escalate_top_path, 'escalate.sh'), template_user_sh)
    write_file_content(path.join(escalate_top_path, 'escalate.csh'), template_user_csh)


def patch_geant4():
    print("PATCHING GEANT4")
    geant4_lib_dir = "{conda_env_path}/lib/Geant4-10.6.0".format(conda_env_path=conda_env_path)
    if not os.path.isdir(geant4_lib_dir):
        print("Cant patch GEANT directory: '{}' does not exists".format(geant4_lib_dir))
        return
    source_file_path = path.join(geant4_lib_dir, 'Geant4PackageCache.cmake')

    patterns = [
        ('geant4_set_and_check_package_variable(OPENGL_INCLUDE_DIR',
         'geant4_set_and_check_package_variable(OPENGL_INCLUDE_DIR "{conda_env_path}/include" PATH "Path to a file.")\n'
            .format(conda_env_path=conda_env_path)),

        ('geant4_set_and_check_package_variable(OPENGL_gl_LIBRARY',
         'geant4_set_and_check_package_variable(OPENGL_gl_LIBRARY "{conda_env_path}/x86_64-conda_cos6-linux-gnu/sysroot/usr/lib64/libGL.so" FILEPATH "Path to a library.")\n'
            .format(conda_env_path=conda_env_path)),

        ('geant4_set_and_check_package_variable(OPENGL_glu_LIBRARY',
         'geant4_set_and_check_package_variable(OPENGL_glu_LIBRARY "{conda_env_path}/lib/libGLU.so" FILEPATH "Path to a library.")\n'
            .format(conda_env_path=conda_env_path))
    ]

    fh, target_file_path = mkstemp()
    with open(target_file_path, 'w') as target_file:
        with open(source_file_path, 'r') as source_file:
            for line in source_file:
                for search, replace_line in patterns:
                    if line.startswith(search):
                        line = replace_line
                        print(line)
                        break
                target_file.write(line)

    remove(source_file_path)
    move(target_file_path, source_file_path)


def setup_jupyterlab():
    config_path = path.join(conda_env_path, 'etc', 'jupyter', 'jupyter_notebook_config.py')
    print(config_path)
    print(template_jupyter_config)
    write_file_content(config_path, template_jupyter_config)

    script_path = path.join(escalate_top_path, 'setup_jupyterlab.sh')
    run_as_bash_script(script_path, template_setup_jupyterlab)


if __name__ == "__main__":
    steps = OrderedDict()

    steps['install_miniconda'] = install_miniconda
    steps['setup_conda'] = setup_conda
    steps['env_scripts'] = generate_env_scripts
    #steps['patch_geant4'] = patch_geant4
    steps['build_ejana_g4e'] = build_ejana_g4e
    steps['setup_jupyterlab'] = setup_jupyterlab

    # This is to print argparse help
    steps_help = "Install steps (in default order):\n" + "\n".join(["   "+s for s in steps.keys()])

    parser = argparse.ArgumentParser(epilog=steps_help, formatter_class=argparse.RawDescriptionHelpFormatter)
    parser.add_argument('-s', "--step",
                        help="Name of installation step. 'all' (default) - full installation",
                        default='all')

    parser.add_argument("--build-root", help="Build root from sources instead of installing from conda", action="store_true", default=False)
    args = parser.parse_args()

    if args.step == 'all':
        for step_func in steps.values():
            step_func()
    elif args.step in steps.keys():
        steps[args.step]()
    else:
        parser.print_help()

